<template>
	<div>
		<flash-message transitionIn="animated swing" class="myCustomClass"></flash-message>
		<div style="margin-bottom: 30px;">
		<!-- If user has searched for a ride -->

			<div class="container-fluid search-ride-form">
				<div v-if="!airport">
					<!--<div v-if="!synapse">-->
						<div class="row">
							<div class="col-md-3" id="starts" style="z-index: 999 !important;">
								<div class="frm-ride loc_pin">
									<div id='mapfrom' style="z-index: 999 !important;"></div>
									<div class="search-form">
										<div id='geocoderFrom' class='geocoder'></div>
									</div>
								</div>
							</div>
							<div class="col-md-3" id="ends">
								<div class="frm-ride loc_pin">
									<div id='mapto'></div>
									<div id='geocoderTo' class='geocoder search-form' placeholder="search destination"></div>
								</div>
							</div>
							<div class="col-md-3">
								<div class="mapboxgl-ctrl-geocoder-airport">
									<div style="float:left; padding: 15px 10px 0 15px; min-width:50px; display:inline; font-size: 20px;">
										<i class="fa fa-calendar-o"></i>
									</div>
									<div style="display:inline-flex;">
										<datepicker icon="calendar-today" v-model="findridepicker" class="mapbox-datepicker" style="display:inline-flex;"></datepicker>
									</div>
								</div>
							</div>
							<div class="col-md-3">
								<button type="submit" @click="searchRides()" class="form-control ridesearch" id="findButton strLoader">
									Search
								</button>
							</div>

						</div>

						<div class="row top-margin-15 bottom-margin-10" v-if="!synapse">
							<div class="col-md-12">
								<div class="search_filters">
									<small>Airport Ride</small>
									<toggle-button v-model="airport" @change="changeToAirport()" style="z-index: 1 !important;" />
								</div>
								<div class="search_filters">
									<input type="checkbox" v-model="ladies_only" ><label>Women Only</label>
								</div>
								<!-- too cluttered / /too many options with this and its not critical or important
								<div class="search_filters">
									<label>Max Price</label>
									<span class="glyphicon glyphicon-minus control_price" id="minus_max" @click="priceDecrease"></span>
									<input name="max_price" type="number" class="price_input" id="max_price" v-model="ridePrice">
									<span class="glyphicon glyphicon-plus control_price" id="max_max" @click="priceIncrease"></span>
								</div>-->
							</div>
						</div>
					<!--</div>-->

					<!-- Synapse 
					<div v-if="synapse">
						<div class="row">
							<div class="col-md-3" id="starts" style="z-index: 999 !important;">
								<div class="mapboxgl-ctrl-geocoder-airport">
									<div style="float:left; padding: 15px 10px 0 15px; width:50px; display:inline; font-size: 20px;">
										<i class="fa fa-calendar-o"></i>
									</div>
	
									<div style="display:inline-flex;">
										<datepicker icon="calendar-today" v-model="findridepicker" class="mapbox-datepicker"></datepicker>
									</div>
								</div>
							</div>
							<div class="col-md-6">
								<div class="search_filters" style="display: inline">
									<p> <strong>Filter Results:</strong></p>
									<input type="checkbox" v-model="ladies_only" ><label>Women Only</label>
								</div>
							</div>
							
							<div class="col-md-3">
								<button type="submit" @click="searchSynapse()" class="form-control ridesearch" id="findButton strLoader">
									Search
								</button>
							</div> 
						</div>
					</div>	-->
				</div>

				<div class="widget user-dashboard-profile form-group" v-if="airport">
					<div class="row">
						<div class="col-md-4">
							<div class="mapboxgl-ctrl-geocoder-airport">
								<div style="float:left; padding: 17px 10px 0 15px; width:50px; display:inline; font-size: 20px;">
									<i class="fa fa-plane"></i>
								</div>
								<div style="display:inline-flex;">
									<select v-model="rideFrom" class="mapbox-airport" name="Select Airport" style="z-index: 999 !important;">
										<option value="" selected disabled> Select an airport </option>
										<option v-for="air in airports" :value="air"> {{air.name}} {{air.city}}</option>
									</select>
								</div>
								<div style="clear:both;"></div>
							</div>
						</div>
						<div class="col-md-4">
							<div class="mapboxgl-ctrl-geocoder-airport">
								<div style="float:left; padding: 15px 10px 0 15px; width:50px; display:inline; font-size: 20px;">
									<i class="fa fa-calendar-o"></i>
								</div>
								<div style="display:inline-flex;">
									<datepicker icon="calendar-today" v-model="findridepicker" class="mapbox-datepicker"></datepicker>
								</div>
							</div>
						</div>
						<div class="col-md-4">
							<button type="submit" @click="searchAirport()" class="form-control ridesearch">
								Search
							</button>
						</div>
					</div>
					<div class="row top-margin-15 bottom-margin-10">
						<div class="col-md-2">
							<small style="color: #222;">Airport Ride</small>
							<toggle-button v-model="airport" @change="changeToAirport()" />
						</div>
					</div>
				</div>
			</div>
		</div>

		<loading :active.sync="isLoading"
				 :can-cancel="true"
				 :is-full-page="true">
		</loading>
	</div>
</template>

<script>
	import { ToggleButton } from 'vue-js-toggle-button'

	import Datepicker from 'vuejs-datepicker';
	import axios from 'axios';
	import Loading from 'vue-loading-overlay';

	// Import stylesheet
	import 'vue-loading-overlay/dist/vue-loading.css';
	var moment = require('moment');


	export default {

    	name: "searchbar",
		components:{Loading, Datepicker, axios,ToggleButton},
		props:['synapse'],
		mounted(){
				mapboxgl.accessToken = 'pk.eyJ1Ijoicm9za2E1NDEiLCJhIjoiY2p4dHVweW9wMHlmczNjbWJxbjR4dzJnaCJ9.kyGpjUF1VhS5DOphBSfp4g';
				var mapfrom = new mapboxgl.Map({
				container: 'mapfrom',
				style: 'mapbox://styles/mapbox/streets-v11',
				center: [-79.4512, 43.6568],
				zoom: 13
				});

				var geocoderFrom = new MapboxGeocoder({
				accessToken: mapboxgl.accessToken,
				mapboxgl: mapboxgl
				});

				document.getElementById('geocoderFrom').appendChild(geocoderFrom.onAdd(mapfrom));

				mapboxgl.accessToken = 'pk.eyJ1Ijoicm9za2E1NDEiLCJhIjoiY2p4dHVweW9wMHlmczNjbWJxbjR4dzJnaCJ9.kyGpjUF1VhS5DOphBSfp4g';
				var mapto = new mapboxgl.Map({
				container: 'mapto',
				style: 'mapbox://styles/mapbox/streets-v11',
				center: [-79.4512, 43.6568],
				zoom: 13
				});

				var geocoderTo = new MapboxGeocoder({
					accessToken: mapboxgl.accessToken,
					mapboxgl: mapboxgl
				});

				document.getElementById('geocoderTo').appendChild(geocoderTo.onAdd(mapto))
				document.querySelector('#geocoderFrom .mapboxgl-ctrl-geocoder--input').addEventListener('change', this.populateFrom);
				document.querySelector('#geocoderTo .mapboxgl-ctrl-geocoder--input').addEventListener('change', this.populateTo);
				document.querySelector('#geocoderFrom .mapboxgl-ctrl-geocoder--input').placeholder = "Starting Point";
				document.querySelector('#geocoderTo .mapboxgl-ctrl-geocoder--input').placeholder = "Destination";


			},

		  data() {
		    return {
					rideFrom: "",
					rideTo: "",
					ridePrice: null,
					findridepicker: new Date(),
					allStates:"",
					isLoading:false,
					fullPage: false,
					ladies_only:false,
					airport:false,
					airports:'',

			};
		  },

		methods: {
				parseLocation(ride){
					this.location = ride.split(", ");
					this.city = this.location[0]
					this.state = this.location[1]
					this.country = this.location[2]

					this.countryList = {
						'United States of America': 'USA',
						'Canada': 'CA',
					},

					this.stateList = {
								'Arizona': 'AZ',
								'Alabama': 'AL',
								'Alaska':'AK',
								'Arkansas': 'AR',
								'California': 'CA',
								'Colorado': 'CO',
								'Connecticut': 'CT',
								'Delaware': 'DE',
								'Florida': 'FL',
								'Georgia': 'GA',
								'Hawaii': 'HI',
								'Idaho': 'ID',
								'Illinois': 'IL',
								'Indiana': 'IN',
								'Iowa': 'IA',
								'Kansas': 'KS',
								'Kentucky': 'KY',
								'Louisiana': 'LA',
								'Maine': 'ME',
								'Maryland': 'MD',
								'Massachusetts': 'MA',
								'Michigan': 'MI',
								'Minnesota': 'MN',
								'Mississippi': 'MS',
								'Missouri': 'MO',
								'Montana': 'MT',
								'Nebraska': 'NE',
								'Nevada': 'NV',
								'New Hampshire': 'NH',
								'New Jersey': 'NJ',
								'New Mexico': 'NM',
								'New York': 'NY',
								'North Carolina': 'NC',
								'North Dakota': 'ND',
								'Ohio': 'OH',
								'Oklahoma': 'OK',
								'Oregon': 'OR',
								'Pennsylvania': 'PA',
								'Rhode Island': 'RI',
								'South Carolina': 'SC',
								'South Dakota': 'SD',
								'Tennessee': 'TN',
								'Texas': 'TX',
								'Utah': 'UT',
								'Vermont': 'VT',
								'Virginia': 'VA',
								'Washington': 'WA',
								'West Virginia': 'WV',
								'Wisconsin': 'WI',
								'Wyoming': 'WY',
								'Alberta': 'AB',
				        'British Columbia': 'BC',
				        'Manitoba': 'MB',
				        'New Brunswick': 'NB',
				        'Newfoundland': 'NF',
				        'Northwest Territory': 'NT',
				        'Nova Scotia': 'NS',
				        'Nunavut': 'NU',
				        'Ontario': 'ON',
				        'Prince Edward Island': 'PE',
				        'Quebec': 'QC',
				        'Saskatchewan': 'SK',
				        'Yukon': 'YT',

							},

							this.state = this.getStateTwoDigitCode(this.state);
							this.country = this.getCountry(this.country);


							this.city = this.city + ", "
							this.state= this.state + ", "

							this.city = this.city.concat(this.state);
							ride = this.city.concat(this.country);
							return ride;

				},

				getStateTwoDigitCode(state) {
					state = this.stateList[state]
					return state
				},

				getCountry(country){
					country = this.countryList[country]
					return country
				},

				populateFrom(){

					this.rideFrom = document.querySelector('#geocoderFrom .mapboxgl-ctrl-geocoder--input').value;
					this.rideFrom = this.parseLocation(this.rideFrom);
				},

				populateTo(){

					this.rideTo = document.querySelector('#geocoderTo .mapboxgl-ctrl-geocoder--input').value;
					this.rideTo = this.parseLocation(this.rideTo)
					console.log(this.rideTo)


				},


				priceIncrease(){
					this.ridePrice++;
					console.log(this.ridePrice)

				},

				priceDecrease(){
					if(this.ridePrice >0){
						this.ridePrice--;
						console.log(this.ridePrice)
					}

				},
				changeToAirport(){
					if(this.airport){
						this.isLoading = true;
						axios.get('/rides/getAirports', {
							body:{
								'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
							}
						}).then(response => {
							this.isLoading = false;
							this.airports = response.data;

						}).catch(e => {
							this.isLoading = false;
							this.flash('Server 500 error please try again', 'error',{timeout: 4500});
						})
					}else{
						location.reload();

					}

				},
				searchAirport(){
					this.isLoading = true;
					axios.post('/rides/searchAirport', {
						body:{
							'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
							'date':this.findridepicker,
							'airport':this.rideFrom,
						}
					}).then(response => {
						this.isLoading = false;
						if(response.data.action === 1) {
							this.$root.$emit('PopulateRides', response.data);
						}else{
							this.$root.$emit('NoRides', 'No Rides');
						}

					}).catch(e => {
						this.isLoading = false;
						this.flash('Server 500 error please try again', 'error',{timeout: 4500});
					});
				},
				searchRides(){
					this.isLoading = true;
					this.$root.$emit('cleandata');

	            	axios.post('/rides/list', {
		                body:{
	                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
	                        'start':this.rideFrom,
	                    	'stop':this.rideTo,
	                        'date':this.findridepicker,
	                        'price':this.ridePrice,
	                        'women_only':this.ladies_only
	                    }
		            }).then(response => {
		            	this.isLoading = false;
		            	if(response.data.action === 1) {
							this.$root.$emit('PopulateRides', response.data);
						}else{
							this.$root.$emit('NoRides', 'No Rides');
						}

					}).catch(e => {
						this.isLoading = false;
						this.flash('Server 500 error please try again', 'error',{timeout: 4500});
						console.log(e);
		            })


				},
				searchSynapse(){
					this.isLoading = true;

	            	axios.post('/synapse/getRides', {
		                body:{
	                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
	                        'date':this.findridepicker,
	                        'women_only':this.ladies_only
	                    }
		            }).then(response => {
		            	this.isLoading = false;

		            	if(response.data.action === 1) {
							this.$root.$emit('PopulateRides', response.data);
							console.log('rides');
						}else{
							this.$root.$emit('NoRides', 'No Rides');
							console.log('no rides');
						}

					}).catch(e => {
						this.isLoading = false;
						this.flash('Server 500 error please try again', 'error',{timeout: 4500});
						console.log(e);
		            })
				},
				getState(state){
					var code = this.allStates.filter( function(itm){
						itm.name == state;
					});

					return code;
				}
			}
    }

</script>
